//+------------------------------------------------------------------+
//|                                                        macdik.mq4 |
//|                                    Copyright (C) 2010 Vikon      |
//|                        |
//+------------------------------------------------------------------+
#property copyright "macdik" 

#property indicator_separate_window
#property indicator_buffers 4
#property indicator_color1 LimeGreen
#property indicator_color2 Orange
#property indicator_color3 Gray
#property indicator_color4 Red
#property indicator_width1 3
#property indicator_width2 3
#property indicator_width3 2
#property indicator_width4 2

extern int FastEma   = 1;
extern int SlowEma   = 5;
extern int SignalSma = 5;
extern int Price     = PRICE_CLOSE;
      
double b[],bu[],bd[],s[];
//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//

int init()
{
   SetIndexBuffer(0,bu); SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(1,bd); SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(2,b);
   SetIndexBuffer(3,s);
   return(0);
}
int deinit()
{
   return(0);
}
//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
            int limit = MathMin(Bars-counted_bars,Bars-1);

   for(int i=limit; i>=0; i--)
   {
      int i1=i+1;
      int i2=i+2;
      
      double b0=iMACD(NULL,0,FastEma,SlowEma,SignalSma,Price,MODE_MAIN,i);
      double b1=iMACD(NULL,0,FastEma,SlowEma,SignalSma,Price,MODE_MAIN,i1);
      double b2=iMACD(NULL,0,FastEma,SlowEma,SignalSma,Price,MODE_MAIN,i2);
      double s0=iMACD(NULL,0,FastEma,SlowEma,SignalSma,Price,MODE_SIGNAL,i);
      bu[i] = EMPTY_VALUE;
      bd[i] = EMPTY_VALUE;
      s[i]  = (b0-s0)*10000;
      b[i]  = ((b1-b2)-(b1-b0))*10000;
         if (b[i]>0) bu[i] = b[i];
         if (b[i]<0) bd[i] = b[i];
   }
   return(0);
}


